(function(global, factory) {
  typeof exports === "object" && typeof module !== "undefined"
    ? factory(exports, require("react"))
    : typeof define === "function" && define.amd
    ? define(["exports", "react"], factory)
    : factory((global.ReactKV = {}), global.React);
})(this, function(exports, React) {
  "use strict";

  /*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
  /* global Reflect, Promise */

  var extendStatics = function(d, b) {
    extendStatics =
      Object.setPrototypeOf ||
      ({ __proto__: [] } instanceof Array &&
        function(d, b) {
          d.__proto__ = b;
        }) ||
      function(d, b) {
        for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
      };
    return extendStatics(d, b);
  };

  function __extends(d, b) {
    extendStatics(d, b);
    function __() {
      this.constructor = d;
    }
    d.prototype =
      b === null ? Object.create(b) : ((__.prototype = b.prototype), new __());
  }

  var __assign = function() {
    __assign =
      Object.assign ||
      function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
          s = arguments[i];
          for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
      };
    return __assign.apply(this, arguments);
  };

  var KEY_CODE;
  (function(KEY_CODE) {
    KEY_CODE[(KEY_CODE["ARROW_LEFT"] = 37)] = "ARROW_LEFT";
    KEY_CODE[(KEY_CODE["ARROW_RIGHT"] = 39)] = "ARROW_RIGHT";
    KEY_CODE[(KEY_CODE["ARROW_DOWN"] = 40)] = "ARROW_DOWN";
    KEY_CODE[(KEY_CODE["ARROW_UP"] = 38)] = "ARROW_UP";
  })(KEY_CODE || (KEY_CODE = {}));
  var KEY_CODE$1 = KEY_CODE;

  function isGreaterEnd(index, listEnd) {
    return index + 1 >= listEnd;
  }
  function isLessStart(index, listStart) {
    return index <= listStart;
  }

  var Grid = (function(_super) {
    __extends(Grid, _super);
    function Grid(props) {
      var _this = _super.call(this, props) || this;
      _this.right = function() {
        if (_this.state.xIndex + 1 < _this.props.rowCount) {
          _this.setState(function(_a) {
            var xIndex = _a.xIndex,
              rowStart = _a.rowStart,
              rowEnd = _a.rowEnd;
            var comp = isGreaterEnd(xIndex, rowEnd);
            return {
              xIndex: xIndex + 1,
              rowEnd: comp ? rowEnd + 1 : rowEnd,
              rowStart: comp ? rowStart + 1 : rowStart
            };
          });
        }
      };
      _this.left = function() {
        var xIndex = _this.state.xIndex;
        if (xIndex > 0) {
          _this.setState(function(_a) {
            var xIndex = _a.xIndex,
              rowStart = _a.rowStart,
              rowEnd = _a.rowEnd;
            var comp = isLessStart(xIndex, rowStart);
            return {
              xIndex: xIndex - 1,
              rowStart: comp ? rowStart - 1 : rowStart,
              rowEnd: comp ? rowEnd - 1 : rowEnd
            };
          });
        }
      };
      _this.down = function() {
        if (_this.state.yIndex + 1 < _this.props.columnCount) {
          _this.setState(function(_a) {
            var yIndex = _a.yIndex,
              columnStart = _a.columnStart,
              columnEnd = _a.columnEnd;
            var comp = isGreaterEnd(yIndex, columnEnd);
            return {
              yIndex: yIndex + 1,
              columnEnd: comp ? columnEnd + 1 : columnEnd,
              columnStart: comp ? columnStart + 1 : columnStart
            };
          });
        }
      };
      _this.up = function() {
        if (_this.state.yIndex > 0) {
          _this.setState(function(_a) {
            var yIndex = _a.yIndex,
              columnStart = _a.columnStart,
              columnEnd = _a.columnEnd;
            var comp = isLessStart(yIndex, columnStart);
            return {
              yIndex: yIndex - 1,
              columnStart: comp ? columnStart - 1 : columnStart,
              columnEnd: comp ? columnEnd - 1 : columnEnd
            };
          });
        }
      };
      _this.onKeyDown = function(event) {
        switch (event.keyCode) {
          case KEY_CODE$1.ARROW_DOWN:
            _this.down();
            break;
          case KEY_CODE$1.ARROW_UP:
            _this.up();
            break;
          case KEY_CODE$1.ARROW_LEFT:
            _this.left();
            break;
          case KEY_CODE$1.ARROW_RIGHT:
            _this.right();
            break;
        }
      };
      _this.state = {
        columnStart: 0,
        columnEnd: props.visibleColumns,
        yIndex: 0,
        rowStart: 0,
        rowEnd: props.visibleRows,
        xIndex: 0
      };
      return _this;
    }
    Grid.prototype.render = function() {
      var _a = this.state,
        rowStart = _a.rowStart,
        rowEnd = _a.rowEnd,
        columnStart = _a.columnStart,
        columnEnd = _a.columnEnd,
        xIndex = _a.xIndex,
        yIndex = _a.yIndex;
      var _b = this.props,
        rowWidth = _b.rowWidth,
        visibleRows = _b.visibleRows,
        renderer = _b.renderer,
        rowCount = _b.rowCount,
        columnCount = _b.columnCount;
      var result = [];
      for (var i = columnStart; i < columnEnd; i++) {
        var row = [];
        for (var j = rowStart; j < rowEnd; j++) {
          row.push(
            renderer({
              rowIndex: j,
              columnIndex: i,
              yIndex: yIndex,
              xIndex: xIndex
            })
          );
        }
        result.push(React.createElement("tr", null, row));
      }
      return React.createElement(
        "table",
        __assign({ tabIndex: 0, onKeyDown: this.onKeyDown }, this.props.dom),
        React.createElement("tbody", null, result)
      );
    };
    return Grid;
  })(React.Component);

  var List = (function(_super) {
    __extends(List, _super);
    function List(props) {
      var _this = _super.call(this, props) || this;
      _this.up = function() {
        var currentIndex = _this.state.currentIndex;
        if (currentIndex > 0) {
          _this.setState(function(_a) {
            var currentIndex = _a.currentIndex,
              start = _a.start,
              end = _a.end;
            var comp = isLessStart(currentIndex, start);
            return {
              currentIndex: currentIndex - 1,
              start: comp ? start - 1 : start,
              end: comp ? end - 1 : end
            };
          });
        }
      };
      _this.down = function() {
        if (_this.state.currentIndex + 1 < _this.props.count) {
          _this.setState(function(_a) {
            var currentIndex = _a.currentIndex,
              end = _a.end,
              start = _a.start;
            var comp = isGreaterEnd(currentIndex, end);
            return {
              currentIndex: currentIndex + 1,
              end: comp ? end + 1 : end,
              start: comp ? start + 1 : start
            };
          });
        }
      };
      _this.onKeyDown = function(event) {
        switch (event.keyCode) {
          case KEY_CODE$1.ARROW_DOWN:
            _this.down();
            break;
          case KEY_CODE$1.ARROW_UP:
            _this.up();
            break;
        }
      };
      _this.state = {
        currentIndex: 0,
        start: 0,
        end: props.visibleCount
      };
      return _this;
    }
    List.prototype.render = function() {
      var _a = this.state,
        start = _a.start,
        end = _a.end,
        currentIndex = _a.currentIndex;
      var _b = this.props,
        renderRow = _b.renderRow,
        count = _b.count,
        visibleCount = _b.visibleCount,
        rowHeight = _b.rowHeight;
      var result = [];
      for (var i = start; i < end; i++) {
        if (i + 1 <= count) {
          result.push(renderRow(i, currentIndex));
        } else {
          break;
        }
      }
      return React.createElement(
        "div",
        __assign(
          {
            style: { height: visibleCount * rowHeight },
            onKeyDown: this.onKeyDown,
            tabIndex: 0
          },
          this.props.dom
        ),
        result
      );
    };
    return List;
  })(React.Component);

  var Table = (function(_super) {
    __extends(Table, _super);
    function Table(props) {
      var _this = _super.call(this, props) || this;
      _this.up = function() {
        var currentIndex = _this.state.currentIndex;
        if (currentIndex > 0) {
          _this.setState(function(_a) {
            var currentIndex = _a.currentIndex,
              start = _a.start,
              end = _a.end;
            var comp = isLessStart(currentIndex, start);
            return {
              currentIndex: currentIndex - 1,
              start: comp ? start - 1 : start,
              end: comp ? end - 1 : end
            };
          });
        }
      };
      _this.down = function() {
        if (_this.state.currentIndex + 1 < _this.props.count) {
          _this.setState(function(_a) {
            var currentIndex = _a.currentIndex,
              start = _a.start,
              end = _a.end;
            var comp = isGreaterEnd(currentIndex, end);
            return {
              currentIndex: currentIndex + 1,
              end: comp ? end + 1 : end,
              start: comp ? start + 1 : start
            };
          });
        }
      };
      _this.onKeyDown = function(event) {
        switch (event.keyCode) {
          case KEY_CODE$1.ARROW_DOWN:
            _this.down();
            break;
          case KEY_CODE$1.ARROW_UP:
            _this.up();
            break;
        }
      };
      _this.state = {
        currentIndex: 0,
        start: 0,
        end: props.visibleCount
      };
      return _this;
    }
    Table.prototype.render = function() {
      var _this = this;
      var _a = this.state,
        start = _a.start,
        end = _a.end,
        currentIndex = _a.currentIndex;
      var _b = this.props,
        renderRow = _b.renderRow,
        renderRowColumn = _b.renderRowColumn,
        count = _b.count,
        visibleCount = _b.visibleCount,
        rowHeight = _b.rowHeight,
        header = _b.header;
      var result = [];
      for (var i = start; i < end; i++) {
        if (i + 1 <= count) {
          var col = [];
          for (var j = 0; j < header.length; j++) {
            col.push(renderRowColumn(i, j));
          }
          result.push(renderRow(i, currentIndex, col));
        } else {
          break;
        }
      }
      return React.createElement(
        "table",
        __assign({}, this.props.dom, {
          onKeyDown: this.onKeyDown,
          tabIndex: 0
        }),
        React.createElement(
          "tbody",
          null,
          React.createElement(
            "tr",
            null,
            this.props.header.map(function(value, index) {
              return React.createElement(
                "th",
                { key: index },
                _this.props.renderHeader(value, index)
              );
            })
          ),
          result
        )
      );
    };
    return Table;
  })(React.Component);

  exports.List = List;
  exports.Table = Table;
  exports.Grid = Grid;

  Object.defineProperty(exports, "__esModule", { value: true });
});
